/*  Testprogramm mit verbesserter Fehlerbehandlung
    Bei fehlerhafter Eingabe wird sofort eine Fehlermeldung ausgegeben,
    Abfrage weiterer Eingaben und Berechnung werden nicht vorgenommen.
*/

/* Copyright (C) 2014-2017 - HS Schmalkalden. All rights reserved. */

#define _CRT_SECURE_NO_WARNINGS 1
#include <stdio.h>



/** Hauptprogramm.
    @return 0 bei Erfolg, alle anderen Werte bedeuten Fehler.
*/
int
main(void)
{
    double    anfgew; /* Anfangsgewicht in kg */
    double    endgew; /* Endgewicht in kg */
    double    aprowo; /* Gewichtsabnahme pro Woche in kg */
    double    jetztg; /* Jetziges Gewicht */
    int       wochen; /* Anzahl abgelaufener Wochen */

    printf("Anfangsgewicht in kg: ");
    scanf("%lg", &anfgew);
    if (0.0 < anfgew) {
        printf("Endgewicht in kg: ");
        scanf("%lg", &endgew);
        if (0.0 < endgew) {
            if (anfgew >= endgew) {
                printf("Gewichtsabnahme pro Woche in kg: ");
                scanf("%lg", &aprowo);
                if (0.0 < aprowo) {
                    wochen = 0;
                    jetztg = anfgew;
                    do {
                        wochen++;
                        jetztg = jetztg - aprowo;
                        printf(
                            "Gewicht nach %d Woche(n): %lg kg\n", wochen, jetztg
                        );
                    } while (jetztg > endgew);
                }
                else {
                    printf(
                    "FEHLER: Gewichtsabnahme/Woche muss groesser als 0 sein!\n"
                    );
                }
            }
            else {
                printf(
                "FEHLER: Endgewicht muss kleiner als Anfangsgewicht sein!\n"
                );
            }
        }
        else {
            printf("FEHLER: Das Endgewicht muss groesser als 0 sein!\n");
        }
    }
    else {
      printf("FEHLER: Das Anfangsgewicht muss groesser als 0 sein!\n");
    }
    return 0;
}

/* vim: set ai sw=4 ts=4 expandtab : */
