/** @file ex021a.c Beispiel fuer moduluebergreifenen Zugriff auf Variablen.
*/

/* Copyright (C) 2014-2017 - HS Schmalkalden. All rights reserved. */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <limits.h>
#include "ex021b.h"


/** Ergebnis der Multiplikation.
*/
int ergebnis = 0;

/** Wert in int-Variable einlesen.
    @param  txt     Text, der als Prompt-Zeichen ausgegeben wird, darf
                    NULL sein.
    @param  dptr    Adresse der Variable, die gesetzt werden soll.
    @return 1 bei Erfolg, 0 bei Fehlschlag.
*/
int
dataread_int(const char *txt, int *dptr);

/** Hauptprogramm.
    @return 0 bei Erfolg, alle anderen Werte bedeuten Fehler.
*/
int
main(void)
{
    int   x   = 0;    /* Erster Faktor */
    int   y   = 0;    /* Zweiter Faktor */

    if(dataread_int("Erster Faktor: ", &x)) {
        if(dataread_int("Zweiter Faktor: ", &y)) {
            ex021b_multiplikation(x, y);
            printf("Ergebnis: %d\n", ergebnis);
        }
    }
    return 0;
}



int
dataread_int(const char *txt, int *dptr)
{
    char      tl[64];
    char      *endptr;
    char      *testptr;
    long      value;
    int       back = 0;
    if (NULL != dptr) {
        if (NULL != txt) {
            fputs(txt, stdout);
        }
        if (fgets(tl, sizeof(tl), stdin)) {
            endptr = NULL;
            errno = 0;
            value = strtol(tl, &endptr, 10);
            if (NULL != endptr) {
                if (endptr == tl) {
                    fputs("Fehler, kein ganzzahliger Wert!\n", stderr);
                }
                else {
                    if (    (ERANGE == errno)
                            && ((LONG_MIN == value) || (LONG_MAX == value))
                    ) {
                        fputs("Fehler, Bereichsueberlauf!\n", stderr);
                    }
                    else {
                        if ((INT_MAX < value) || (INT_MIN > value)) {
                            fputs("Fehler, Bereichsueberlauf!\n", stderr);
                        }
                        else {
                            back = 1;
                            testptr = endptr;
                            while ('\0' != *testptr) {
                                switch (*testptr) {
                                    case ' ': case '\t': case '\r': case '\n': {
                                    } break;
                                    default: {
                                        back = 0;
                                    } break;
                                }
                                testptr++;
                            }
                            if (1 == back) {
                                *dptr = value;
                            }
                            else {
                                fputs(
                                    "Fehler, nicht verarbeitbarer Text am Ende",
                                    stderr
                                );
                                fputs(
                                    " der Eingabe: ",
                                    stderr
                                );
                                fputs(endptr, stdout);
                            }
                        }
                    }
                }
            }
            else {
                *dptr = value;
                back = 1;
            }
        }
    }
    return back;
}



/* vim: set ai sw=4 ts=4 expandtab : */
