/**	@file   he-read.h   Daten von Standardeingabe einlesen,
	bei Problemen Fehlermeldung in deutscher Sprache ausgeben.
*/

/* Copyright (C) 2014 - HS Schmalkalden. All rights reserved. */

#ifndef HE_READ_H_INCLUDED
#define	HE_READ_H_INCLUDED 1

#ifdef __cplusplus
extern "C" {
#endif

/**	Double-Wert einlesen.
	@param	msg	Anzuzeigender Text, der Nutzer zur Eingabe auffordert.
			Darf NULL sein.
	@param	dptr	Zeiger auf Zielvariable.
	@return	1 bei Erfolg, 0 bei Misserfolg.
*/
int
hsm_et_read_double(char const *msg, double *dptr);

/**	Integer-Wert einlesen.
	@param	msg	Anzuzeigender Text, der Nutzer zur Eingabe auffordert.
			Darf NULL sein.
	@param	dptr	Zeiger auf Zielvariable.
	@return	1 bei Erfolg, 0 bei Misserfolg.
*/
int
hsm_et_read_int(char const *msg, int *dptr);

/**	String einlesen.
	@param	msg	Anzuzeigender Text, der Nutzer zur Eingabe auffordert.
			Darf NULL sein.
	@param	dptr	Zeiger auf Zieladdresse.
	@param	buffer	Zeiger auf temporären Puffer.
	@param	sz	Groesse der Puffer dptr und buffer.
	@return 1 bei Erfolg, 0 bei Misserfolg.
*/
int
hsm_et_read_string(char const *msg, char *dptr, char *buffer, size_t sz);

#ifdef __cplusplus
}
#endif

#endif

/* vim: set ai sw=4 ts=4 expandtab : */

