/** @file ex024.c Demo-Programm fuer Schreiben einer Text-Datei
	unter Windows.
*/

/* Copyright (C) 2014-2017 - HS Schmalkalden. All rights reserved. */

#ifndef _WIN32
error "Dieses Programm kann nur unter Windows erstellt werden!"
#endif



#include <stdio.h>
#include <stdlib.h>
#include <process.h>



/** Dateiname der zu schreibenden Datei.
*/
static const char filename[] = { "C:\\Temp\\C\\testfile.txt" };



/** Hauptprogramm.
	@return 0 bei Erfolg, alle anderen Werte bedeuten Fehler.
*/
int
main(void)
{
	FILE  *outf   = NULL;         /* Datei-Zeiger */
	int    exc    = EXIT_FAILURE; /* Exit-Code des Programmes. */
	int    i      = 5;            /* Variable fuer Testzwecke */
	int    errc   = 0;            /* Ergebnis von fopen_s() */

	errc = fopen_s(&outf, filename, "w");
	if (0 == errc) {

		/* Erfolg im Rueckgabecode vermerken */
		exc = EXIT_SUCCESS;

		/* Falls Schreiben der Textzeile fehlschlaegt, Misserfolg */
		if (EOF == fputs("Dies ist ein Test-String", outf)) {
			exc = EXIT_FAILURE;
		}

		/* Falls Schreiben des Newline fehlschlaegt, Misserfolg */
		if (EOF == fputc('\n', outf)) {
			exc = EXIT_FAILURE;
		}

		/* Falls Schreiben der formatierten Ausgabe fehlschlaegt, Misserfolg */
		if (0 > fprintf(outf, "Der Wert der Variablen ist %d\n", i)) {
			exc = EXIT_FAILURE;
		}

		/* Falls Schliessen der Datei fehlschlaegt, Misserfolg */
		if (0 != fclose(outf)) {
			exc = EXIT_FAILURE;
		}
		outf = NULL;
	}
	exit(exc); return exc;
}

/* vim: set ai sw=4 ts=4 : */
