/*  Beispiel ex084.c: Verwendung von Zeigern auf Funktionen.
*/
#define	_CRT_SECURE_NO_WARNINGS 1
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*	Konstanter Text auf linker Seite des Vergleiches.
*/
const char str1[] = { "Das ist ein Test." };

/*	Konstanter Text auf rechter Seite des Vergleiches.
*/
const char str2[] = { "DIES IST EIN TEST." };

/*  Typ von Vergleichsfunktionen:
    Die Vergleichsfunktionen bekommen zwei Zeiger auf konstante
    char-Felder und geben einen int-Wert fuer das Vergleichsergebnis
    zurueck. Dieser ist positiv wenn der linke String "groesser" ist
    als der rechte, 0 wenn beide Strings gleich bewertet werden
    und negativ wenn der linke String "kleiner" ist als der rechte.
*/
typedef
int
text_compare_fct(const char *, const char *);


int
main(void)
{
    text_compare_fct *fctptr;   /* Zeiger auf eine Vergleichsfunktion */
    int               i;        /* Vergleichsergebnis */
    
    /*	Zeiger auf Adresse der Funktion strcmp setzen.
    */
    fctptr = strcmp;

    /*  Bildschirmausgabe, mit welcher Funktion der Vergleich erfolgt.
    */
    printf("Vergleich \"%s\" und \"%s\" mit strcmp\n", str1, str2);

    /*  Zeiger dereferenzieren und Funktion aufrufen, Ergebnis speichern.
    */
    i = (*fctptr)(str1, str2);

    /*  Ergebnis ausgeben.
    */
    printf("Ergebnis: %d\n\n", i);

    /*	Jetzt _stricmp verwenden (auf Nicht-Windows-Systemen strcasecmp).
    */
    fctptr = _stricmp;
    printf("Vergleich \"%s\" und \"%s\" mit _stricmp\n", str1, str2);
    i = (*fctptr)(str1, str2);
    printf("Ergebnis: %d\n\n", i);

    return EXIT_SUCCESS;
}

/* vim: set ai sw=4 ts=4 : */
