/*  Beispiel ex085.c: Verwendung von Zeigern auf Funktionen.
*/
#define _CRT_SECURE_NO_WARNINGS 1
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*  Konstanter Text auf linker Seite des Vergleiches.
*/
const char str1[] = { "Das ist ein Test." };

/*  Konstanter Text auf rechter Seite des Vergleiches.
*/
const char str2[] = { "DIES IST EIN TEST." };



int
main(void)
{
    int (*fctptr)(const char *, const char *);  /* Zeiger auf eine Vergleichsfunktion */
    int i;                                      /* Vergleichsergebnis */
    
    /*	Funktion strcmp verwenden.
    */
    fctptr = strcmp;
    printf("Vergleich \"%s\" und \"%s\" mit strcmp\n", str1, str2);
    i = (*fctptr)(str1, str2);
    printf("Ergebnis: %d\n\n", i);

    /*	Funktion _stricmp verwenden.
    */
    fctptr = _stricmp;
    printf("Vergleich \"%s\" und \"%s\" mit _stricmp\n", str1, str2);
    i = (*fctptr)(str1, str2);
    printf("Ergebnis: %d\n\n", i);

    return EXIT_SUCCESS;
}

/* vim: set ai sw=4 ts=4 : */
