/*  Beispiel ex086.c: Verwendung von Zeigern auf Funktionen.
*/
#define	_CRT_SECURE_NO_WARNINGS 1
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*  Konstanter Text auf linker Seite des Vergleiches.
*/
const char str1[] = { "Das ist ein Test." };

/*  Konstanter Text auf rechter Seite des Vergleiches.
*/
const char str2[] = { "DIES IST EIN TEST." };

/*  Vergleichen zweier Strings und Ausgabe des Ergebnisses.
    Das dritte Argument ist ein Zeiger auf eine Funktion, die zwei
    Zeiger auf konstante Felder mit Zeichen als Argument erhaelt
    und einen int-Wert zurueckgibt.
*/
void
vergleichen_und_ausgeben(
    const char *s1,
    const char *s2,
    int (*vergleichsfunktion)(const char *, const char *)
)
{
    int	i;		/* Vergleichsergebnis */

    printf("Vergleich von \"%s\" und \"%s\"\n", s1, s2);
    i = (*vergleichsfunktion)(s1, s2);
    printf("Ergebnis: %d\n\n", i);
}


int
main(void)
{
    printf("Vergleich mit strcmp\n");
    vergleichen_und_ausgeben(str1, str2, strcmp);

    printf("Vergleich mit _strcimp\n");
    vergleichen_und_ausgeben(str1, str2, _stricmp);

    return EXIT_SUCCESS;
}

/* vim: set ai sw=4 ts=4 : */
