/** @file   he-longso.c Long zu String konvertieren.
*/

/* Copyright (C) 2014-2017 - HS Schmalkalden. All rights reserved. */

#include "he-conf.h"

#if HAVE_STDLIB_H
#include <stdlib.h>
#endif
#if HAVE_STDINT_H
#include <stdint.h>
#endif
#if HAVE_LIMITS_H
#include <limits.h>
#endif

#include "he-ulongso.h"
#include "he-longso.h"
#include "he-error.h"


int
hsm_et_long_to_string(char *rb, size_t sz, long l, int *ec)
{
	int       back    =   0;
	if ((NULL != rb) && (2 < sz)) {
		if (0L <= l) {
			back = hsm_et_ulong_to_string(rb, sz, (unsigned long)l, ec);
		}
		else {
			rb[0] = '-';
			if (LONG_MIN != l) {
				back = hsm_et_ulong_to_string(
					&(rb[1]), (sz - 1), (unsigned long)(0L - l), ec
				);
			}
			else {
				back = hsm_et_ulong_to_string(
					&(rb[1]), (sz - 1), ((unsigned long)LONG_MAX + 1UL), ec
				);
			}
		}
	}
	else {
		hsm_et_error_set(ec, HE_ERROR_INVALID_ARGS);
	}
	return back;
}

/* vim: set ai sw=4 ts=4 : */

