
#include "he-conf.h"

#include <stdio.h>

#include "he-numco.h"
#include "he-error.h"
#include "he-long.h"
#include "he-longso.h"
#include "he-longfo.h"


static const long	testdata[] = {
  -9223372036854775807L,
  -4294967295L,
  -2147483647L,
  -20L,
  -5L,
  0L,
  5L,
  20L,
  2147483647L,
  4294967295L,
  9223372036854775807L
};

static const size_t sz_testdata = sizeof(testdata)/sizeof(unsigned long);

int main(int argc, char *argv[])
{
  size_t	i;
  size_t	j;
  long		res;
  int		ec;

  printf("LONG_MIN = %ld\n", LONG_MIN);
  printf("LONG_MAX = %ld\n", LONG_MAX);
  for (i = 0; i < sz_testdata; i++) {
    for (j = 0; j < sz_testdata; j++) {
#if 1
      printf("%ld %ld\n", testdata[i], testdata[j]);
#else
      hsm_et_long_to_file(stdout, testdata[i], NULL, NULL);
      fputc(' ', stdout);
      hsm_et_long_to_file(stdout, testdata[j], NULL, NULL);
      fputc('\n', stdout);
#endif
      ec = HE_ERROR_NONE;
      res = hsm_et_long_add(testdata[i], testdata[j], &ec);
#if 1
      printf("\t+ %ld (%d)\n", res, ec);
#else
      fputs("\t+ ", stdout);
      hsm_et_long_to_file(stdout, res, NULL, NULL);
      fputs(" (", stdout);
      hsm_et_long_to_file(stdout, (long)ec, NULL, NULL);
      fputs(")\n", stdout);
#endif
      ec = HE_ERROR_NONE;
      res = hsm_et_long_sub(testdata[i], testdata[j], &ec);
#if 1
      printf("\t- %ld (%d)\n", res, ec);
#else
      fputs("\t- ", stdout);
      hsm_et_long_to_file(stdout, res, NULL, NULL);
      fputs(" (", stdout);
      hsm_et_long_to_file(stdout, (long)ec, NULL, NULL);
      fputs(")\n", stdout);
#endif
      ec = HE_ERROR_NONE;
      res = hsm_et_long_mul(testdata[i], testdata[j], &ec);
#if 1
      printf("\t* %ld (%d)\n", res, ec);
#else
      fputs("\ŧ* ", stdout);
      hsm_et_long_to_file(stdout, res, NULL, NULL);
      fputs(" (", stdout);
      hsm_et_long_to_file(stdout, (long)ec, NULL, NULL);
      fputs(")\n", stdout);
#endif
      ec = HE_ERROR_NONE;
      res = hsm_et_long_div(testdata[i], testdata[j], &ec);
#if 1
      printf("\t/ %ld (%d)\n", res, ec);
#else
      fputs("\t/ ", stdout);
      hsm_et_long_to_file(stdout, res, NULL, NULL);
      fputs(" (", stdout);
      hsm_et_long_to_file(stdout, (long)ec, NULL, NULL);
      fputs(")\n", stdout);
#endif
    }
  }
  return 0;
}


