
#include "he-conf.h"

#include <stdio.h>

#include "he-error.h"
#include "he-ulong.h"
#include "he-ulongso.h"
#include "he-ulongfo.h"
#include "he-longfo.h"

static const unsigned long	testdata[] = {
  0UL, 5UL, 20UL, 2147483647UL, 4294967295UL,
  9223372036854775807UL, 18446744073709551615UL
};

static const size_t sz_testdata = sizeof(testdata)/sizeof(unsigned long);

int main(int argc, char *argv[])
{
  size_t	i;
  size_t	j;
  unsigned long	res;
  int		ec;

  for (i = 0; i < sz_testdata; i++) {
    for (j = 0; j < sz_testdata; j++) {
#if 0
      printf("%lu %lu\n", testdata[i], testdata[j]);
#else
      hsm_et_ulong_to_file(stdout, testdata[i], NULL, NULL);
      fputc(' ', stdout);
      hsm_et_ulong_to_file(stdout, testdata[j], NULL, NULL);
      fputc('\n', stdout);
#endif
      ec = HE_ERROR_NONE;
      res = hsm_et_ulong_add(testdata[i], testdata[j], &ec);
#if 0
      printf("+ %lu (%d)\n", res, ec);
#else
      fputs("+ ", stdout);
      hsm_et_ulong_to_file(stdout, res, NULL, NULL);
      fputs(" (", stdout);
      hsm_et_long_to_file(stdout, (long)ec, NULL, NULL);
      fputs(")\n", stdout);
#endif
      ec = HE_ERROR_NONE;
      res = hsm_et_ulong_sub(testdata[i], testdata[j], &ec);
#if 0
      printf("- %lu (%d)\n", res, ec);
#else
      fputs("- ", stdout);
      hsm_et_ulong_to_file(stdout, res, NULL, NULL);
      fputs(" (", stdout);
      hsm_et_long_to_file(stdout, (long)ec, NULL, NULL);
      fputs(")\n", stdout);
#endif
      ec = HE_ERROR_NONE;
      res = hsm_et_ulong_mul(testdata[i], testdata[j], &ec);
#if 0
      printf("* %lu (%d)\n", res, ec);
#else
      fputs("* ", stdout);
      hsm_et_ulong_to_file(stdout, res, NULL, NULL);
      fputs(" (", stdout);
      hsm_et_long_to_file(stdout, (long)ec, NULL, NULL);
      fputs(")\n", stdout);
#endif
      ec = HE_ERROR_NONE;
      res = hsm_et_ulong_div(testdata[i], testdata[j], &ec);
#if 0
      printf("/ %lu (%d)\n", res, ec);
#else
      fputs("/ ", stdout);
      hsm_et_ulong_to_file(stdout, res, NULL, NULL);
      fputs(" (", stdout);
      hsm_et_long_to_file(stdout, (long)ec, NULL, NULL);
      fputs(")\n", stdout);
#endif
    }
  }
  return 0;
}


