
#include <io.h>
#include <fcntl.h>
#include <stdio.h>


int main(void)
{
	int	oldmode;

	/*	Auf internationalen Mode (16-Bit-Text) umschalten, alten Mode
		sichern.
	*/
	oldmode = _setmode(_fileno(stdout), _O_U16TEXT);

	/*	Byte-Order-Marker als erstes Zeichen ausgeben.
		Fuer Text-Dateien immer.
		Fuer stdout nur wenn Umleitung in Datei erfolgt, nicht bei
		Ausgabe	ins Terminal.
	*/
	if (0 == _isatty(_fileno(stdout))) { fputwc(0xFEFF, stdout); }

	/*	Nicht-ASCII-Zeichen duerfen nicht im Quelltext vorkommen, auch
		nicht in Strings oder Kommentaren. Deshalb numerische Angabe.
		Das %lc ist der Platzhalter fuer einen wide (long) character.
		UNICODE-Zeichen koennen auch mit Backslash-u und 16-Bit-Hexwert
		in den String geschrieben werden. Dabei müssen exakt 4
		Hexadezimalstellen verwendet werden.
		Fuer UNICODE-Zeichen oberhalb von 0xFFFF kann Backslash-U
		(hier mit grossem U) verwendet werden, darauf muessen exakt
		8 Hexadezimalstellen folgen.
	*/
	fwprintf(stdout, L"Im Sommer haben wir bis zu 35%lcC.\n", 0x00B0 );
	fputws(L"Im Winter bis -20\u00B0C.\n", stdout);

	/*	Sicherstellen, dass alles ausgegeben wurde.
	*/
	fflush(stdout);

	/*	Falls stderr benutzt wurde, auch dieses flushen.
	*/

	/*	Urspruenglichen Mode wiederherstellen.
	*/
	_setmode(_fileno(stdout), oldmode);

	return 0;
}

